SndBuf homer => dac;
"special:dope" => homer.read;

1.0 => float SENSEX;
1.0 => float SENSEY;

float theta,x,y,vx,vy,ax,ay;
340 => float XMAX => float YMAX;
0.98 => float DAMP;

MAUI_View myWinder; myWinder.size(400,400); 
myWinder.name("Accelerometer Config Screen");
MAUI_Button one; one.size(400,400); one.position(0,0);0 => one.state;
one.name("Accelerometer config.\n Lean (you and your) laptop forward and to the left \nHold there a bit...");
myWinder.addElement(one);
myWinder.display();
MAUI_LED dude; 

4.0 :: second => now;

Hid hi;
HidMsg msg;

FileIO config;
    one.position(0,0);
    one.size(200,200);
    one.toggleType();
    dude.color(0);  
    200 => x;
    200 => y;
    dude.position(x,y);
    myWinder.addElement(dude);
    one.name("So if the bubble\nwere a marble,it\nwould roll toward\nthis button. Don't\nworry if it doesn't\nroll to the right\nposition at this time...");
    if( !hi.openTiltSensor() )  {
        <<< "tilt sensor unavailable", "" >>>;
        me.exit();
    }

    0 => float hangTime;
    while (hangTime < 5.0)  {
        0.05 :: second => now;
        0.05 + hangTime => hangTime;
        updatePhysics();
        if (checkButt(one))  {
            dude.light();
            1 => one.state;
	    5.0 => hangTime;
        }
        else {
            dude.unlight();
            0 => one.state;
        }
    }
    
    -msg.x/Std.abs(msg.x) => SENSEX;
    -msg.y/Std.abs(msg.y) => SENSEY;
    <<< msg.x, msg.y, SENSEX, SENSEY >>>;
    
    config.open( "CONFIG.txt", FileIO.WRITE );
    if (config.good())  {
        config.write("SENSEX ");
        config.write(SENSEX);
        config.write("\n");
        config.write("SENSEY ");
        config.write(SENSEY);
        config.write("\n");
        config.close();
    }
    else   {
        <<< "Couldn't create CONFIG file!!!" >>>;
    }

one.size(400,400); one.position(0,0);0 => one.state;
one.name("Config all done!!\nI'm gonna exit now.\nPlease rerun the app.");
0 => homer.pos;
3.0 :: second => now;

10 => int TOLERANCE;

fun int checkButt(MAUI_Button butt)  {
    if (x > butt.x()-10 & x < butt.x()+20 
           & y > butt.y()-10 & y < butt.y()+20) return 1;
    else return 0;
}
               
fun void updatePhysics() {
    hi.read( 9, 0, msg );
    SENSEX*msg.x*0.01 => ax;
    -SENSEY*msg.y*0.01 => ay;
    vx*DAMP + ax => vx; 
    x + vx => x; 
    if (x > XMAX) {
        XMAX => x;
        -vx => vx;
    }
    if (x < 0) {
        0 => x;
        -vx => vx;
    }
    vy*DAMP + ay => vy; 
    y + vy => y;
    if (y > YMAX) {
        YMAX => y;
        -vy => vy;
    }
    if (y < 0) {
        0 => y;
        -vy => vy;
    }
    dude.position(x,y);
}    
